CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  STEERING      = 0
  THROTTLE      = 1

  THREV         = 1200
  THOFF         = 1500
  THFWD         = 1800

  STLFT         = 1200
  STCTR         = 1500
  STRGT         = 1800
  
OBJ

  pst   : "Parallax Serial Terminal"
  s2    : "S2"

PUB  start | lftrgt, fwdrev

  pst.start(9600)
  s2.start
  s2.start_motors
  repeat
    lftrgt := ((pulse_in(STEERING) #> STLFT <# STRGT) - STCTR) * 256 / constant(STRGT - STLFT)
    lftrgt &= ||lftrgt > 20
    fwdrev := ((pulse_in(THROTTLE) #> THREV <# THFWD) - THOFF) * 256 / constant(THFWD - THREV)
    fwdrev &= ||fwdrev > 20
    s2.move_now(fwdrev - lftrgt, fwdrev + lftrgt, 0, (||fwdrev #> ||lftrgt >> 1) >> 3, 1)     

PUB pulse_in(pin) | t0, t1

  waitpne(1 << pin, 1 << pin, 0)
  waitpeq(1 << pin, 1 << pin, 0)
  t0 := cnt
  waitpne(1 << pin, 1 << pin, 0)
  t1 := cnt
  return (t1 - t0) / (clkfreq / 1_000_000)  